//
//  ViewController.m
//  EasyConfig
//
//  Created by cz on 1/21/14.
//  Copyright (c) 2014 cz. All rights reserved.
//

#import "ViewController.h"
#import <SystemConfiguration/CaptiveNetwork.h>
int amount_flg = 0;
#define over_time 60 //超时时间
BOOL start_flg = NO;
@interface ViewController ()
@end
@implementation ViewController
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [_inputTextField addTarget:self action:@selector(endEdit:) forControlEvents:UIControlEventEditingDidEndOnExit];
    [_sendButton addTarget:self action:@selector(sendButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
    [_cancelButton addTarget:self action:@selector(cancelButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
    __EasyConfig = nil;

    tview.delegate = self;
    tview.dataSource = self;
    mac = [[NSMutableArray alloc] init];
    [mac removeAllObjects];
    ip = [[NSMutableArray alloc] init];
    [ip removeAllObjects];
    [proView setProgress:(0)];//重置进度条
    proValue = 0;
    NSDictionary *ifs = [self fetchSSIDInfo];
    if (ifs != nil)
    {
        NSString *ssid = ifs[@"SSID"];
        [_ssid setText:ssid];
    }else{
        [_ssid setText:@"Not Found"];
        _ssid.textColor = [UIColor redColor];
        [_sendButton setUserInteractionEnabled:NO];
        _sendButton.enabled = NO;
        [_cancelButton setUserInteractionEnabled:NO];
        _cancelButton.enabled = NO;
    }

}
-(id)fetchSSIDInfo
{
    NSArray *ifs = (__bridge id)CNCopySupportedInterfaces();
    //NSLog(@"%s: Supported interfaces: %@", __func__, ifs);
    id info = nil;
    for (NSString *ifnam in ifs) {
        info = (__bridge id)CNCopyCurrentNetworkInfo((__bridge CFStringRef)ifnam);
        if (info && [info count]) {
            break;
        }
    }
    return info;
}

- (NSString *)currentWifiSSID {
    // Does not work on the simulator.
    NSString *ssid = nil;
    NSArray *ifs = (__bridge   id)CNCopySupportedInterfaces();
    NSLog(@"ifs:%@",ifs);
    for (NSString *ifnam in ifs) {
        NSDictionary *info = (__bridge id)CNCopyCurrentNetworkInfo((__bridge CFStringRef)ifnam);
        NSLog(@"dici：%@",[info  allKeys]);
        if (info[@"SSIDD"]) {
            ssid = info[@"SSID"];
            
        }
    }
    return ssid;
}
- (IBAction)select_amount:(id)sender {
    UISegmentedControl * myseg = (UISegmentedControl *) sender;
    if (myseg.selectedSegmentIndex == 0) {
        amount_flg = 0;
    }
    else
    {
        amount_flg = 1;
    }
    
}
-(void)changeProgress
{
    proValue += (0.1*600)/over_time;
    if(proValue > (600))
    {
        //停用计时器
        [timer_Progress setFireDate:[NSDate distantFuture]];
    }
    else
    {
        [proView setProgress:(proValue/600)];//重置进度条
    }
}
-(void)cancelButtonClicked:(UIButton *)button{
    [self SendStop];
}
-(void)onSwitch:(UISwitch *)onSwitch{
    if(onSwitch.on==YES){
        [_inputTextField setSecureTextEntry:NO];
    }else if(onSwitch.on==NO){
        [_inputTextField setSecureTextEntry:YES];
    }
}
-(void)endEdit:(UITextField *)textField{
    [self.view endEditing:YES];
}
-(void)RecvWithPacket:(RecvPacket *)recvPacket{
    NSLog(@"name:%@",recvPacket.module_name);
    NSLog(@"mac:%@",recvPacket.module_mac);
    NSLog(@"ip:%@",recvPacket.module_ip);
    
    [mac addObject: recvPacket.module_mac];
    [ip addObject: recvPacket.module_ip];
    
    if (amount_flg == 0){
        [self SendStop];
    }
    else{
        [tview reloadData];
    }
}

-(void)sendButtonClicked:(UIButton *)button{
    [mac removeAllObjects];
    [ip removeAllObjects];
    [tview reloadData];
    [self.view endEditing:YES];
    [_select_amount setEnabled:NO];
    NSString *pskStr=_inputTextField.text;
    __EasyConfig = [[EasyConfig alloc] init:self];
    if (_hidessid.isOn == NO) {
        [__EasyConfig SendDataWithPsk:pskStr andSSID:nil];//IF WIFI SSID NO HIDE
    }
    else{
        [__EasyConfig SendDataWithPsk:pskStr andSSID:_ssid.text];//IF WIFI SSID HIDE
    }
    [_sendButton setUserInteractionEnabled:NO];
    _sendButton.enabled = false;
    proValue = 0;
    timer_Progress = [NSTimer scheduledTimerWithTimeInterval:0.1
                                              target:self
                                            selector:@selector(changeProgress)
                                            userInfo:nil
                                             repeats:YES];
    [timer_Progress setFireDate:[NSDate distantPast]];
    
    timer_stop = [NSTimer scheduledTimerWithTimeInterval:over_time
                                             target:self
                                           selector:@selector(timer_stop_callback)
                                           userInfo:nil
                                            repeats:NO];
    start_flg = YES;
}
-(void)timer_stop_callback{
    [self SendStop];
}

-(void)SendStop{
    if (start_flg == YES) {
        start_flg = NO;
        NSLog(@"stop");
        [__EasyConfig stop_send];//停止配置
        [_sendButton setUserInteractionEnabled:YES];
        _sendButton.enabled = YES;
        [timer_Progress setFireDate:[NSDate distantFuture]];
        [timer_stop setFireDate:[NSDate distantFuture]];
        [proView setProgress:(0)];
        proValue = 0;
        [_select_amount setEnabled:YES];
        if ([mac count]== 0) {
            [mac removeAllObjects];
            [ip removeAllObjects];
            [mac addObject: @"Not Found!"];
            [ip addObject: @""];
        }
        [tview reloadData];
    }
}
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [mac count];
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 50;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    if (cell==nil)
    {
        cell=[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
        label_mac=[[UILabel alloc] initWithFrame:CGRectMake(15, 0, 2000, 44)];
        label_ip=[[UILabel alloc] initWithFrame:CGRectMake(15, 18, 500, 44)];
        label_mac.font  = [ UIFont fontWithName: @"Arial" size: 13.0 ];
        label_ip.font  = [ UIFont fontWithName: @"Arial" size: 12.0 ];
        label_mac.tag=101;
        label_ip.tag=102;
        [cell.contentView addSubview:label_mac];
        [cell.contentView addSubview:label_ip];
    }
    label_mac=(UILabel*)[cell.contentView viewWithTag:101];
    label_ip=(UILabel*)[cell.contentView viewWithTag:102];

    label_mac.text=[mac objectAtIndex:indexPath.row];
    label_ip.text=[ip objectAtIndex:indexPath.row];
    return cell;
}
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    NSString *str = @"module info";
    return str;
}
- (CGFloat) tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 30.0;
}
- (UITableViewCellEditingStyle)tableView:(UITableView *)tv editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	return UITableViewCellEditingStyleDelete;
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)hidessid:(id)sender {
    
}
@end
